/* Novy tell.c ver.2.1                  */
/* copyright (c)1997 by Marek Zelem     */
/* e-mail: marek@terminus.sk    */

#include <stdio.h>
#include <unistd.h>
#include <string.h>
//#include <utmp.h>
#include "utmp_lib.h"
#include <pwd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <signal.h>
#include <grp.h>
#include <mmm/io_lib.h>
#include <mmm/text_lib.h>
//#include <mmm/ll_lib.h>
#include <mmm/dynamic.h>
#include <mmm/net_lib.h>
#include "tell.h"

#define BAD_ALARM

extern char *ttyfile_badown, *ttyfile_badtype;

time_t prev_time;
char prev_toname[1024];

int timeout_read( int fd, void *buf, int count, int secs )
{ fd_set fds;
  struct timeval tv;
	FD_ZERO(&fds);
	FD_SET(fd,&fds);
	tv.tv_sec=secs;
	tv.tv_usec=0;
	if( select(fd+1,&fds,NULL,NULL,&tv)>0 && FD_ISSET(fd,&fds) )
		return( read(fd,buf,count) );
	return(-1);
}

int write_message(t_st *tab, char *tty, uchar *text, char *mailto)
{ int f,wait4reply;
  time_t tim;
  char *format;
  char *p;
  struct stat st;
  char year[32];
  uchar pom[128];
  uchar tims[64];
  uchar sl[128];
  ddata_t *dbuf;
  int r,i,w,jj,col;
  int nextline;
	if( (dbuf=dd_alloc(1,1024))==NULL )	return(0);
	nextline=0;
	format=tab->format;
	time(&tim);
	if( prev_time==tim && !strncmp(tty,"/dev/",5) && !strncmp(prev_toname,g_toname,1023) )
		nextline=1;
	strncpy(pom,ctime(&tim),127);
	if(pom[0]!=0)	pom[strlen(pom)-1]=0;
	sscanf(pom,"%s %s %s %s %s",sl,sl,sl,tims,year);
	p=pom; i=0;
	while( i<4 && (p=strchr(p,' '))!=NULL )	{ while(*p==' ') p++; i++; }
	if( p!=NULL )	*(p-1)=0;
	i=0; w=0; col=0;
	while( format[i]!=0 && ( tab->maxlen<0 || tab->maxlen>dd_n(dbuf) ) )
	{	jj=dd_n(dbuf);
		if(format[i]=='%')
		{	i++;
			switch( format[i] )
			{ case 'u':	dd_append(dbuf,g_name,strlen(g_name));
					break;
			  case 'h':	dd_append(dbuf,g_host,strlen(g_host));
					break;
			  case 'r':	dd_append(dbuf,g_toname,strlen(g_toname));
					break;
			  case 'n':	dd_append(dbuf,me,strlen(me));
					break;
			  case 'p':	dd_append(dbuf,tell_type,strlen(tell_type));
					break;
			  case 'l':	dd_printf(dbuf,"%ld",strlen(text));
					break;
			  case 'm':
			  case 's':
				{ int a; uchar b;  a=0;
				  while(text[a]!=0 &&
				    (tab->maxlen<0 || tab->maxlen>dd_n(dbuf)) )
				  { b=text[a];
				    if( !(tab->flags&FL_E8BIT) )
					b&=0x7f;
				    if( !(tab->flags&FL_ECTRL)
						&& b<32 && b!=27 )
					{ a++; continue; }
				    if( !(tab->flags&FL_EESC) && b==27 )
					{ a++; if(text[a]) a++; continue; }
				    if( b<32 && b!=27 
					&& !(tab->ctrls&set_ctrl(b)) )
					{ a++;  continue; }
				    dd_putc(dbuf,b); a++;
				    col++;
				    if( b=='\n' || b=='\r'
				|| (tab->flags&FL_WRAP && col>=tab->wrap) )
				    { if( b!='\n' && b!='\r' )
						dd_putc(dbuf,'\n');
				      dd_append(dbuf,sl,w);
				      col=w;
				    }
				  }
				}	jj=dd_n(dbuf); nextline=0; break;
			  case 'd':	dd_append(dbuf,pom,strlen(pom));
					break;
			  case 'D':	dd_printf(dbuf,"%s %s",pom,year);
			  case 't':	dd_append(dbuf,tims,strlen(tims));
					break;
			  case 0:	i--;
			}
			i++;
		}
		else if(format[i]=='\\')
		{ long a;
			dd_putc(dbuf,tex_parse_backslash(format+i,&a));
			i+=a;
		}
		else	dd_putc(dbuf,format[i++]);
		while(jj<dd_n(dbuf) && w<127)
		{	col++;
			if( (sl[w++]=*((char*)dd_entry(dbuf,jj)))=='\n' )
				{ w=0; col=0; }
			jj++;
		}
		if( w<128 )	sl[w]=0;
		else		sl[127]=0;
		if( nextline )
		{	dd_delete(dbuf,0,dd_n(dbuf));
			dd_append(dbuf,sl,strlen(sl));
		}
	}
	if( tab->maxlen>=0 && tab->maxlen<=dd_n(dbuf) )
		printf("%s: Message is too long!%s",me,eol);
 	dd_putc(dbuf,0);
	f=-1;	/* neotvoreny ziadny vystupny subor */
	wait4reply=0;	/* necakat na odpoved zo suboru ;-) */
	if( stat(tty,&st)==0 )
	{	if( S_ISREG(st.st_mode) || S_ISCHR(st.st_mode)
			|| S_ISFIFO(st.st_mode) )
		{  if( st.st_uid!=to_uid )
		   {
#ifdef MAIL_IF_ERR
		     char pombuf[1024];
		      sprintf(pombuf,ttyfile_badown,g_name,g_host,g_toname,st.st_uid,tty);
		      mail_error(TELLMASTER,"bad owner",pombuf,dd_data(dbuf));
#endif MAIL_IF_ERR
		      dd_free(dbuf); return(0);
		   }
		   else if( !(S_IWUSR & st.st_mode) )
			goto WM_1;
		   f=open(tty,O_WRONLY|O_APPEND);
		}
		else if( S_ISSOCK(st.st_mode) )
		{	if( (f=netnamed_connect(tty))<0 )
				goto WM_1;
			wait4reply=1;
		}
		else
WM_1:		{
#ifdef MAIL_IF_ERR
		  char pombuf[1024];
		   sprintf(pombuf,ttyfile_badtype,g_name,g_host,g_toname,tty);
		   mail_error(mailto,"bad file type",pombuf,dd_data(dbuf));
#endif MAIL_IF_ERR
		   dd_free(dbuf); return(0);
		}
	}
#ifdef ALLOW_EXEC
	else if( tty[0]=='|' )
	{ int p[2];
		p[0]=-1; p[1]=-1;
		socketpair(AF_UNIX,SOCK_STREAM,0,p);
		if( fork()==0 )
		{ darg_t *da;
			close(p[0]);
			close(0);
			close(1);
			close(2);
			dup(p[1]); dup(p[1]); dup(p[1]);
			setgroups(1,&to_gid);
			setgid(to_gid);
			setuid(to_uid);
			/* chdir(home); - uz je */
			da=darg_line2argv(tty+1);
			execvp(darg_argv(da)[0],darg_argv(da));
			write(1,"Error\n",6);
			exit(0);
		}
		wait4reply=1;
		f=p[0];
		close(p[1]);
	}
#endif ALLOW_EXEC
	else
	{
		if( (f=open(tty,O_WRONLY|O_CREAT|O_EXCL,0600))<0 )
		{
#ifdef MAIL_IF_ERR
		  char pombuf[1024];
		   sprintf(pombuf,ttyfile_badtype,g_name,g_host,g_toname,tty);
		   mail_error(mailto,"can't create file",pombuf,dd_data(dbuf));
		   mail_error(TELLMASTER,"can't create file",pombuf,dd_data(dbuf));
#endif MAIL_IF_ERR
		   dd_free(dbuf); return(0);
		}
		fchown(f,to_uid,to_gid);
	}
	r=0;
	if( f>=0 )
		{ write(f,dd_data(dbuf),dd_n(dbuf)-1);
		  r=1;
		  if( wait4reply )
		  { char buf[128];
#ifdef BAD_ALARM
			{ int pos,l,i;
			     pos=0;
			     while( (l=timeout_read(f,buf+pos,128-pos,3))>0 )
			     {	i=0;
			     	while( i<l && buf[pos+i]!='\n' )
				     i++;
				if( i<l )
				{	buf[pos+i]=0;
					break;
				}
				pos+=l;
			     }
			     if( l<=0 )	buf[pos]=0;
			}
#else BAD_ALARM
		  	signal(SIGALRM,net_sigvoid);
			alarm(3);	/* timeout */
		  	net_getln(f,buf,128);
#endif BAD_ALARM
			if( buf[0]!=0 && buf[strlen(buf)-1]=='\n')
				buf[strlen(buf)-1]=0;
			if( buf[0]!=0 )
			{	printf("%s: %s%s",me,buf,eol);
				r=2;
			}
		  }
		  close(f);
		}
	time(&tim);
	if( !strncmp(tty,"/dev/",5) )
	{	prev_time=tim;
		strncpy(prev_toname,g_toname,1023);
	}
	dd_free(dbuf); return(r);
}

int local_tell( char *toname, char *utty, char *text )
{ struct m_utmp *ut;
  struct stat st;
  int num,j,k,i;
  pid_t pid,pid2;
  struct passwd *pw;
  char *tellrc;
  long lentellrc;
  int told;
  char home[64];
  t_st tab[32];
  char pom[1024];

	told=0;
	if( (pw=getpwnam(toname))!=NULL )
	{	to_uid=pw->pw_uid;
		to_gid=pw->pw_gid;
		strncpy(home,pw->pw_dir,63);	home[63]=0;
	}
	else
	{
#ifdef	ALLOW_DUMMY_USERS
		if( toname[0]=='/' )
		{	strncpy(home,toname,63);	home[63]=0;
			if( stat(home,&st)<0 || !S_ISDIR(st.st_mode)
				|| (st.st_mode&S_ISVTX)
				|| (st.st_mode&S_IWGRP)
				|| (st.st_mode&S_IWOTH) )
				goto NotUser;
			if( utty[0]!=0 )	goto NotUser;
			to_uid=st.st_uid;
			to_gid=st.st_gid;
		}
		else
#endif	ALLOW_DUMMY_USERS
		{ char *p=toname;
#ifdef	ALLOW_DUMMY_USERS
NotUser:		if( (p=strrchr(toname,'/'))!=NULL )
				p++;
			else	p=toname;
#endif	ALLOW_DUMMY_USERS
			printf("%s: %s is not user.%s",me,p,eol);
			return(-1);
		}
	}
	chdir(home);
/* nacitame si ~<toname>/.tellrc */
	sprintf(pom,"%s/.tellrc",home);
	if( (tellrc=load_file(pom,&lentellrc))==NULL )
	{
#ifdef	ALLOW_DUMMY_USERS
		if( toname[0]=='/' )	goto NotUser;
#endif	ALLOW_DUMMY_USERS
		tellrc=load_file("/etc/user.tellrc",&lentellrc);
	}

/* upravime tty-cko */
	if( utty[0]!=0 && utty[0]!='*' &&  utty[0]!='/' )
	{  strcpy(pom,utty);
	   if ( strlen(utty)<=2 )
		sprintf(utty,"/dev/tty%s",pom);
	   else
		sprintf(utty,"/dev/%s",pom);
	}

/* Hladame ho v UTMP */
	m_utmpname(_PATH_UTMP);
	m_setutent();
	num=0;
	while(	(ut=m_getutent())!=NULL )
	{
		tab[num].flags=0;
		tab[num].ctrls=CTRLS_DEFAULT;
		tab[num].maxlen= DEFAULT_MAXLEN;
		strcpy(tab[num].format,FORMAT_DEFAULT);
		if( ut->ut_type==USER_PROCESS && !strncmp(toname,ut->ut_user,mUT_NAMESIZE) )
		{
		  sprintf(tab[num].tty,"/dev/%s",ut->ut_line);
		  tab[num].pid=ut->ut_pid;
		  if( stat(tab[num].tty,&st) )
		  {	num--;	}
		  else
		  { tab[num].prior=16;
		    if( !(st.st_mode & S_IWGRP) || st.st_uid!=to_uid )
		  	tab[num].prior=0;
		    tab[num].time=st.st_mtime;
		    pid=tab[num].pid;
		    while( (pid2=getchildpid(pid))!=pid )	pid=pid2;
		    getcmdline(pid,pom+1);
		    pom[0]=' ';	strcpy(pom+strlen(pom)," ");
		    if( tab[num].prior > 0 )
		    	tab[num].prior+=
				tell_getprior(pom,tellrc,lentellrc,tab+num,0);
/* printf("%s %d\n",pom,tab[num].prior); */
		  }
		  num++;
		}
	}
	m_endutent();
/* ak nieco specifikoval */
	if( utty[0]!=0 )
	{
	  for(j=0,k=0,i=0;i<num;i++)
	  { if(utty[0]=='*' || !strcmp(utty,tab[i].tty))
	    { k++;
	      if( tab[i].prior>0 )
	      {	if( write_message(tab+i,tab[i].tty,text,toname) )
		  { j++; told++; }
	      }
	    }
	  }
	if(!k)
	  printf("%s: %s is not logged in on %s.%s",me,toname,utty,eol);
	else if(!j)
	  printf("%s: %s has messages disabled on %s.%s",me,toname,utty,eol);
	}
	else
/* nechal to na mna */
	{
	  for(j=0,i=0;i<num;i++)
	  { if( tab[i].prior>tab[j].prior ) j=i;
	    if( tab[i].prior==tab[j].prior && tab[i].time>tab[j].time ) j=i;
	  }
	  if(!num)
	  {
#ifdef	ALLOW_DUMMY_USERS
	     if( toname[0]!='/' )
#endif	ALLOW_DUMMY_USERS
		printf("%s: %s is not logged in.%s",me,toname,eol);
	  }
	  else if( tab[j].prior<=0 )
	    printf("%s: %s has messages disabled on %s.%s",me,toname,tab[j].tty,eol);
	  else
	  {
	      	if( write_message(tab+j,tab[j].tty,text,toname) )
		{ told++;
		  if( num>1 )
		   printf("%s: %s is logged in %d times; writing to %s%s",me,toname,num,tab[j].tty,eol);
		}
		else
	  	 printf("%s: %s has messages disabled on %s.%s",me,toname,tab[j].tty,eol);
	  }
	}
//	if( utty[0]==0 )	/* iba ak nespecifikoval tty */
	{	if( told )	told=1;
		else		told=2;
		tab[0].flags=0;
		tab[0].ctrls=CTRLS_DEFAULT;
		tab[0].tty[0]=0;
		tab[0].maxlen=DEFAULT_MAXLEN;
		strcpy(tab[0].format,FORMAT_DEFAULT);
 		tell_getprior(NULL,tellrc,lentellrc,tab,told);
		if(tab[0].tty[0]!=0)
		{	/* if(tab[0].tty[0]!='/')
				sprintf(pom,"%s/%s",home,tab[0].tty);
			else */
				sprintf(pom,"%s",tab[0].tty);
			if( write_message(tab,pom,text,toname)==1 )
				printf("%s: %s automaticaly logged your message.%s",me,toname,eol);
		}
	}
	unload_file(tellrc,lentellrc);
	return(0);
}

int local_who( char *toname, char *utty, int mod )
{ struct m_utmp *ut;
  struct stat st;
  pid_t pid,pid2;
  time_t tim;
  char *t;
  char a_tty[64];
  char buf1[32],buf2[32],buf3[32],*p;
  char logtime[128];
  char pom[1024];

	if( utty[0]!=0 && utty[0]!='*' &&  utty[0]!='/' )
	{  strcpy(pom,utty);
	   if ( strlen(utty)<=2 )
		sprintf(utty,"/dev/tty%s",pom);
	   else
		sprintf(utty,"/dev/%s",pom);
	}

/* Hladame ho v UTMP */
	m_utmpname(_PATH_UTMP);
	m_setutent();
	while(	(ut=m_getutent())!=NULL )
	{
		if( ut->ut_type==USER_PROCESS && (!strcmp(toname,"*") || !strncmp(toname,ut->ut_user,mUT_NAMESIZE)) )
		{
		  sprintf(a_tty,"/dev/%s",ut->ut_line);
		  pid=ut->ut_pid;
		  if( (utty[0]!=0 && utty[0]!='*' && strcmp(utty,a_tty)) || stat(a_tty,&st) )
			continue;
		  else
		  { 
		    t="";
		    if( !(st.st_mode & S_IWGRP) )
		  	t="mesg n";
		    strncpy(pom,ctime(&(ut->ut_time)),127);
		    if(pom[0]!=0)	pom[strlen(pom)-1]=0;
		    sscanf(pom,"%s %s %s %s %s",logtime,buf1,buf2,buf3,logtime);
		    if( (p=strrchr(buf3,':'))!=NULL ) *p=0;
		    sprintf(logtime,"%s %2s %s",buf1,buf2,buf3);
		    time(&tim);
		    while( (pid2=getchildpid(pid))!=pid )	pid=pid2;
		    getcmdline(pid,pom);
		    if( mod==0 )
			printf("%-8.8s %-8s %s (%.16s)%s",ut->ut_user,ut->ut_line,logtime,ut->ut_host,eol);
		    else if(mod==1)
			printf("%-8.8s %-8s %s %s\t%ld%s",ut->ut_user,ut->ut_line,logtime,ut->ut_host,(long)(tim-st.st_mtime),eol);
		  }
		}
	}
	m_endutent();
	return(0);
}

